﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Net;
using System.Net.Sockets;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.IO;
namespace wangluoqi
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            //点击监听按钮时 创建Socket对像
            Socket socketWatch = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);//创建一个Socket对象，如果用UDP协议，则要用SocketTyype.Dgram类型的套接字

            //声明ip地址
            IPAddress ip = IPAddress.Any;

            //创建端口对像
            IPEndPoint point = new IPEndPoint(ip, Convert.ToInt32(txtprot.Text));

            //开始监听
            socketWatch.Bind(point);
            ShowMsg("监听成功");
            //声明一秒内可同时连接的客户端
            socketWatch.Listen(10);


            //创建后台进程用来监听连接
            Thread td = new Thread(listen);
            td.IsBackground = true;
            td.Start(socketWatch);



        }
        Socket socketSend;
        Dictionary<string, Socket> dc = new Dictionary<string, Socket>();
        /// <summary>
        /// 创建通信的客户端
        /// </summary>
        /// <param name="o"></param>
        void listen(object o)
        {
            //把对像转成socket 如果不为socket 返回null
            Socket socketwatch = o as Socket;
            while (true)
            {     //等待客户端连接 创建一个负责通信的Socket
                socketSend = socketwatch.Accept();
                dc.Add(socketSend.RemoteEndPoint.ToString(), socketSend);
                comboBox1.Items.Add(socketSend.RemoteEndPoint.ToString());
                ShowMsg(socketSend.RemoteEndPoint.ToString() + ":连接成功");

                //新建一个进程，以免程序假死
                Thread th = new Thread(Receive);
                th.IsBackground = true;
                th.Start(socketSend);


            }
        }

        /// <summary>
        /// 不停的接收传过来的数据
        /// </summary>
        /// <param name="o"></param>
        void Receive(object o)
        {
            try
            {
                while (true)
                {
                    Socket socketSend = o as Socket;

                    byte[] buffer = new byte[1024 * 1024 * 2];
                    int r = socketSend.Receive(buffer);
                    if (r == 0)
                    {
                        break;
                    }
                    string str = Encoding.UTF8.GetString(buffer, 0, r);
                    ShowMsg(socketSend.RemoteEndPoint + ":" + str);
                }
            }
            catch { }
        }

        private void ShowMsg(string str)
        {
            txtlog.AppendText(str + "\r\n");
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            //取消跨线层访问判断
            Control.CheckForIllegalCrossThreadCalls = false;
        }

        private void button4_Click(object sender, EventArgs e)
        {
            string str = txtsend.Text;
            byte[] buf = Encoding.UTF8.GetBytes(str);
            List<byte> blist = new List<byte>();
            blist.Add(0);
            blist.AddRange(buf);
            //将泛型集合转为数组
            byte[] nbuf = blist.ToArray();
                  
            if (comboBox1.SelectedItem == null)
            {
                comboBox1.SelectedIndex = 0;
            }
            dc[comboBox1.SelectedItem.ToString()].Send(nbuf);

        //  socketSend.Send(buf);
        }

        private void button2_Click(object sender, EventArgs e)
        {
            OpenFileDialog odg = new OpenFileDialog();
            odg.InitialDirectory = @"C:\Users\Administrator\Desktop";
            odg.ShowDialog();

            string filepath = odg.FileName;
            txtfilename.Text = filepath;


        }

        //发送文本
        private void button3_Click(object sender, EventArgs e)
        {
            string stpath = txtfilename.Text;
            if (comboBox1.SelectedItem == null)
            {
                comboBox1.SelectedIndex = 0;
            }
            using(FileStream fsRead=new FileStream(stpath,FileMode.OpenOrCreate,FileAccess.Read))
            {
                byte[] buf = new byte[1024 * 1024 * 5];
                int r = fsRead.Read(buf, 0, buf.Length);
                List<byte> nlist= new List<byte>();
                nlist.Add(1);
                nlist.AddRange(buf);
                //将集合转为数组;
                byte[] nbuf = nlist.ToArray();
                dc[comboBox1.SelectedItem.ToString()].Send(nbuf, 0, r+1, SocketFlags.None);
            }
        }

        //发送窗口抖动
        private void button5_Click(object sender, EventArgs e)
        {
            if (comboBox1.SelectedItem == null)
            {
                comboBox1.SelectedIndex = 0;
            }
            byte[] buf = new byte[1];
            buf[0] = 2;
            dc[comboBox1.SelectedItem.ToString()].Send(buf);
        }
    }
}

